local agent_helper = require(AGENT_PATH .. "agent_helper")




function PlatformAdapter:OpenExitDialog()

	local format = { title = "退出", message = "退出游戏?", positive = "确定", negative = "取消", }

	self:OpenAlertDialog(format, function (result) if "positive" == result then 

			agent_helper:Exit(function(result) 
				if "true" == result then
					Log("================ExitExitExitExit")
					AdapterToLua:endGame()
				end
			end)

	end end)

end




AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
    login_verify_url = "http://cls.cp01.youyannet.com/fy5/login_verify.php",
	uid = "",
}




--初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	--浮标里按“切换账号”
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)

end

-- 平台ID
function AgentAdapter:GetSpid()
	return "fy5"
end
-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid().."_" .. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[152] 
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return ""
end

--获得loadingbgname
function AgentAdapter:GetLoadingbgName()
	return ""
end

function AgentAdapter:Login(callback)

	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登陆回调 

end



function AgentAdapter:OnClickBackLogin()
	local callback = function()
		AgentLoginView:OnClickBtnLogin()--重新调出登陆界面
    end
    --自己按“返回”切换账号
	PlatformBinder:JsonCall("call_agent_logout2", "", "", LUA_CALLBACK(self, callback))
end




function AgentAdapter:LoginCallback(result)--登陆后回调
	Log("result===" .. result)

	local json_obj = cjson.decode(result)	

	if nil == json_obj or 
		nil == json_obj.openId  or 
		nil == json_obj.token 
		then return end

	local openId = json_obj.openId
	local token = json_obj.token

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())
	end

	self.is_login_verify_ing = true
	local now_server_time = math.floor(GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time))
	local real_url = string.format("%s?spid=%s&openId=%s&token=%s", self.login_verify_url, self:GetSpid(), openId, token)
	Log("log_real_url==" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end


function AgentAdapter:LogoutCallback(result)--注销回调
	self.uid = ""
	--if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	--end
	return true
end

function AgentAdapter:UIEventCallback(event)--UI事件回调
	if "open" == event then
		--self:ShowFloatButton()
	elseif "close" == event then
		--self:ShowFloatButton()
	end
	return true
end


function AgentAdapter:ShowFloatButton()--显示浮动按钮
	agent_helper:ShowFloatButton()
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买



	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end

    local orderid = server_id .. "_" .. self.uid .. "_" .. os.time()

	local param_obj = {}
	param_obj.price = amount * 100
	param_obj.serverid = server_id
	param_obj.name = "元宝"
	param_obj.oid = orderid

	Log("param_obj==" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj), nil)

end

--元宝变化
function AgentAdapter:OnMoneyChange(gold)
	Log("OnMoneyChange==================")
	Log(gold)
	PlatformBinder:JsonCall("call_agent_on_money_change", gold)
end




function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)

	if self.subit_date_tf == nil then
		self.subit_date_tf = true
		local info = {}

		info.action = 1
		if self.createRole then
			info.action = 2
			self.createRole = nil
			self.subit_date_tf = nil
		end

		info.serverId = zone_id
		info.serverName = zone_name
		info.role_id = role_id
		info.role_name = role_name
		info.role_level = role_level

		self.serverId = zone_id
		self.serverName = zone_name

		PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
	end

end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)

	print("创建角色上报----ReportOnCreateRole")

	self.createRole = true

end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end
