 local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.cp01.youyannet.com/he4/login_verify.php",
	notify_url = "http://cls.cp01.youyannet.com/he4/pay.php",

	uid = "",
}

-- 初始化
function AgentAdapter:Init()
	if self.is_init then return end
	self.is_init = true
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "he4"
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[147] 
end



-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid().."_" .. self.uid
end



function AgentAdapter:LoginCallback(result)
	print("AgentAdapter:LoginCallback:" .. result)
	local json_obj = cjson.decode(result)

	if nil == json_obj or nil == json_obj.uid or nil == json_obj.sid then return end
	self.uid = json_obj.uid
	self.sid = json_obj.sid
	self.login_callback(self:GetPlatName(), self.sid)
	return false
end

function AgentAdapter:Login(callback)
	print("AgentAdapter:Login:")
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))
end

function AgentAdapter:LogoutCallback(result)
	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:Logout()
	self.force_logout = true
	agent_helper:Logout()
end

function AgentAdapter:UIEventCallback(event)
	if "open" == event then
		--self:ShowFloatButton()
	elseif "close" == event then
		--self:ShowFloatButton()
	end
	return true
end

function AgentAdapter:ShowFloatButton()
	agent_helper:ShowFloatButton(70, 30, true)
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end
	local  json_obj = {}
	json_obj.price = amount
	json_obj.waresid = 1
	json_obj.waresname = "元宝"
	json_obj.cporderid = server_id .. "_" .. self.uid .. "_" .. os.time()
	json_obj.cpprivateinfo = "cpprivateinfo"
	json_obj.notifyurl = self.notify_url
	agent_helper:Pay(cjson.encode(json_obj), nil)
end

function AgentAdapter:EnterUserCenter()
	agent_helper:EnterUserCenter()
end

-- 是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end