local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "http://cls.cp01.youyannet.com/hxd/login_verify.php",
	uid = "",
}

--退出
function PlatformAdapter:OpenExitDialog()
	agent_helper:Exit(function(result) 
		if "true" == result then
			AdapterToLua:endGame()
		end
	end)
end

-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "hxd"
end

-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return self:GetSpid().."_".. self.uid
end

--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[149] --神魔无双
end


-- 是否有管理中心
function AgentAdapter:IsHasManagerCenter()
	return false
end

--管理中心按钮监听
function AgentAdapter:OpenManagerCenter()
	if self:IsHasManagerCenter() then
		PlatformBinder:JsonCall("call_agent_open_mc", "", "")
	end
end




function AgentAdapter:Login(callback)
	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

function AgentAdapter:OnClickBackLogin()
	agent_helper:Logout()
end

function AgentAdapter:OnClickRestartGame()
	agent_helper:Logout()
end

function AgentAdapter:LoginCallback(result)--登录后回调

	local json_obj = cjson.decode(result)

	
    local t = {
		 uid = json_obj.uid,
		 tstamp = json_obj.tstamp,
		 sign = json_obj.sign,
     }


     local real_url = string.format("%s?spid=%s&device=%s", self.login_verify_url, self:GetSpid(), tostring(PlatformAdapter.GetPhoneUniqueId()))

	for i,v in pairs(t) do
		real_url=string.format(real_url.."&"..i.."=%s",v)
	end

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		agent_helper:ShowFloatButton()
	end

	self.is_login_verify_ing = true
	
	Log("log_real_url====" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

function AgentAdapter:LogoutCallback(result)--注销回调

	self.uid = ""
	if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end

	local param_obj = {}
	param_obj.serverId=server_id
	param_obj.roleName=role_name
	param_obj.extraInfo=server_id .. "_" .. self.uid .. "_" .. os.time()
	param_obj.itemName="元宝"
	param_obj.amount=amount
	param_obj.count=amount*10
	param_obj.ratio=10
    local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then
		param_obj.roleLevel= role_vo.level or 0
		param_obj.serverName = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
	else
	    param_obj.roleLevel= 0
		param_obj.serverName = "__"
	end
	Log("AgentAdapter:Pay======" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj), nil)
end

-- 创建角色上报
function AgentAdapter:ReportOnCreateRole(role_name)
	-- self:SubmitInfo(2)
end

-- 进入游戏上报
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)
	self:SubmitInfo(1)
end

--  升级上报
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)
	-- self:SubmitInfo(3)
end


function AgentAdapter:SubmitInfo(type)
	local role_vo = GameVoManager.Instance:GetMainRoleVo()
	local user_vo = GameVoManager.Instance:GetUserVo()

	if role_vo ~= nil and user_vo ~= nil then
		local info = {}
		info.roleName = role_vo.role_name
		info.roleLevel = role_vo.level or 0
		info.serverId = user_vo.plat_server_id
		info.serverName = user_vo.plat_server_id .. "服-" .. user_vo.plat_server_name
		Log("AgentAdapter:SubmitInfo======" .. cjson.encode(info))
		agent_helper:SubmitExtendData(cjson.encode(info))
	end
end


--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end
